use crate::{ite, symbols::Symbols};

const POLY1: u32 = 0xF2D05351;
const POLY2: u32 = 0xE4613C47;

const BUDGET: u32 = 22;

pub fn decode(os: &Symbols<f64>) -> Option<(f64, u64)> {
    fn search_31(os: &[u8; 62], mut s: u32, mut b: u32) -> Option<u64> {
        for i in 0..31 {
            s <<= 1;
            let b1 = os[i * 2] as u32;
            let b2 = os[i * 2 + 1] as u32;
            b = b.checked_sub((par(s & POLY1) ^ b1) + (par(s & POLY2) ^ b2))?;
        }
        Some(0)
    }

    fn search(os: &[u8], s: u32, b: u32) -> Option<u64> {
        if let Ok(os) = os.try_into() {
            search_31(os, s, b)
        } else if let [q0, q1, qs @ ..] = os {
            let b1 = *q0 as u32;
            let b2 = *q1 as u32;
            let s0 = (s << 1) | 0;
            let s1 = (s << 1) | 1;
            let m0 = (par(s0 & POLY1) ^ b1) + (par(s0 & POLY2) ^ b2);
            let m1 = (par(s1 & POLY1) ^ b1) + (par(s1 & POLY2) ^ b2);
            let pp = ite!(m0 <= m1, [(s0, m0), (s1, m1)], [(s1, m1), (s0, m0)]);
            for (si, mi) in pp {
                if b >= mi {
                    if let Some(x) = search(qs, si, b - mi) {
                        return Some((x << 1) | (si & 1) as u64);
                    }
                }
            }
            None
        } else {
            None
        }
    }

    for budget in 0..BUDGET {
        if let Some(x) = search(&os.bits(), 0, budget).filter(|x| *x != 0) {
            return Some((budget as f64, x));
        }
    }

    None
}

pub fn decode_loop(os: &Symbols<f64>) -> Option<(f64, u64)> {
    fn search(os: &[[u8; 2]; 81], b: u32) -> Option<u64> {
        const INIT: u8 = 0;
        const NEXT: u8 = 1;
        const BACK: u8 = 2;

        #[derive(Default, Clone, Copy)]
        struct Node {
            sx: u32,
            mx: u32,
            ns: u8,
        }

        let mut nodes = [Node::default(); 50];
        let mut i: usize = 0;
        let mut s: u32 = 0;
        let mut m: u32 = 0;

        loop {
            if m > b {
                m = 0;
                i = i.checked_sub(1)?.min(49);
            } else if i < 50 {
                let n = nodes.get_mut(i)?;
                match n.ns {
                    INIT => {
                        n.ns = NEXT;
                        let b1 = os[i][0] as u32;
                        let b2 = os[i][1] as u32;
                        let s0 = (s << 1) | 0;
                        let s1 = (s << 1) | 1;
                        let m0 = m + (par(s0 & POLY1) ^ b1) + (par(s0 & POLY2) ^ b2);
                        let m1 = m + (par(s1 & POLY1) ^ b1) + (par(s1 & POLY2) ^ b2);
                        if m0 <= m1 {
                            s = s0;
                            m = m0;
                            n.sx = s1;
                            n.mx = m1;
                        } else {
                            s = s1;
                            m = m1;
                            n.sx = s0;
                            n.mx = m0;
                        }
                        i += 1;
                    }
                    NEXT => {
                        n.ns = BACK;
                        s = n.sx;
                        m = n.mx;
                        i += 1;
                    }
                    _ => {
                        n.ns = INIT;
                        i = i.checked_sub(1)?;
                    }
                }
            } else if i < 81 {
                s <<= 1;
                let b1 = os[i][0] as u32;
                let b2 = os[i][1] as u32;
                m += (par(s & POLY1) ^ b1) + (par(s & POLY2) ^ b2);
                i += 1;
            } else {
                let mut r: u64 = 0;
                for j in (0..50).rev() {
                    r <<= 1;
                    r |= ((nodes[j].sx as u64 & 1) ^ (nodes[j].ns as u64 >> 1)) ^ 1;
                }
                return Some(r);
            }
        }
    }

    let mut qs = [[0u8, 0u8]; 81];
    for i in 0..81 {
        qs[i] = [bit(os[i * 2 + 1]) as u8, bit(os[i * 2 + 1]) as u8];
    }

    for budget in 0..BUDGET {
        if let Some(x) = search(&qs, budget).filter(|x| *x != 0) {
            return Some((budget as f64, x));
        }
    }

    None
}

#[inline(always)]
fn bit(x: f64) -> u32 {
    if x > 0.0 {
        1
    } else {
        0
    }
}

#[inline(always)]
fn par(x: u32) -> u32 {
    x.count_ones() % 2
}

pub fn main() {
    // 1: SYMBOLS_HB9AK: Some((18.0, 1029168291166382))
    // 2: SYMBOLS_G4HSB: Some((0.0, 1030104491612783))

    let x = decode(&SYMBOLS_G4HSB);
    println!("1: SYMBOLS_G4HSB: {:?}", x);
    let x = decode(&SYMBOLS_HB9AK);
    println!("1: SYMBOLS_HB9AK: {:?}", x);

    let now = std::time::Instant::now();
    for _ in 0..10 {
        let _ = decode(&SYMBOLS_G4HSB);
    }
    let dt = now.elapsed();
    println!("1: ELAPSED SYMBOLS_G4HSB: {:?}", dt);

    let now = std::time::Instant::now();
    for _ in 0..10 {
        let _ = decode(&SYMBOLS_HB9AK);
    }
    let dt = now.elapsed();
    println!("1: ELAPSED SYMBOLS_HB9AK: {:?}", dt);
}

const SYMBOLS_G4HSB: Symbols<f64> = Symbols([
    75.92018465865411,
    30.709786427422127,
    24.05461909813381,
    -36.89351706492903,
    12.039144481870174,
    42.8417843848912,
    64.03479535132622,
    29.444125456606656,
    35.39517396550115,
    -3.97015205826856,
    -43.76057058446832,
    -51.331451789302065,
    40.60505292328165,
    52.620092753578774,
    -17.493250747397404,
    68.12183700929555,
    -28.964349644596666,
    -14.687993737481357,
    66.44598418354714,
    -14.574742438563039,
    47.09549708186296,
    -73.11339980856147,
    -51.70417619179725,
    33.72809810948098,
    -15.842232161336025,
    -77.20497307449635,
    33.01478993197895,
    -30.13534918443215,
    67.97601041216018,
    25.677306552475525,
    -56.18570526471788,
    -56.47400939919362,
    1.5021164416158017,
    48.58306433725493,
    -28.96821932440343,
    -36.98977291864844,
    36.38471721421054,
    -23.532871651067016,
    -30.555217186402256,
    12.22839267920277,
    -39.117403805643434,
    -78.40384720207663,
    -48.29763071111752,
    -39.255212418522504,
    -24.136208185548632,
    -61.322068888191204,
    -49.02833096396872,
    37.626931226441215,
    -42.35088098315347,
    14.813805170316964,
    55.58172261945472,
    -53.60230303282391,
    -22.141702838595865,
    -51.26396569055331,
    25.385742840290263,
    -54.47965408696007,
    -33.770557991429875,
    -5.355153315151059,
    -67.75869196668242,
    -8.140940301104187,
    53.52372481758828,
    -61.44371145980401,
    -59.49726250001129,
    47.23129594863568,
    -5.725962192371201,
    -64.34262169389402,
    23.799684494222795,
    -16.023136978011717,
    66.40780092695988,
    -29.168073541994058,
    -50.80800370802672,
    -65.27317358716674,
    30.568069354480095,
    33.00797918980732,
    -16.986091233033317,
    -47.99606618232227,
    -44.43170695732367,
    -15.04023548276778,
    -35.10811248510267,
    22.082854931891355,
    -33.30680181581118,
    -72.47078548353417,
    35.30404912733861,
    31.321857576502975,
    -32.62453641802145,
    12.590432460975867,
    -68.04921900592137,
    -60.596178684691075,
    -39.22034379805225,
    -47.89537640710486,
    5.992583465179903,
    -49.93149026950943,
    44.77147344207573,
    -27.755070477275417,
    -54.55303267077774,
    23.3937641755326,
    52.0517059040039,
    -38.213503055316465,
    -8.55565455052431,
    -66.49041658646208,
    22.46855038770546,
    50.173379259334425,
    -59.28542626394979,
    -53.793137305601284,
    36.59939412868001,
    -1.982068949131143,
    -72.8457726040484,
    26.088217990574197,
    25.053939115618807,
    60.91248957288317,
    -26.06947978325491,
    -55.54715765160093,
    69.65960727761666,
    -28.503085091196745,
    35.11066286672841,
    -14.162494773294345,
    36.02818958987752,
    -41.34838589039606,
    -20.11650250880982,
    -35.99095713798336,
    25.04788592424891,
    36.44307658735927,
    78.4232678720221,
    -55.54534238736093,
    -36.89664499442159,
    13.936776724572272,
    67.39184855803451,
    -41.3701999932164,
    33.82513840051858,
    -62.402070716158704,
    19.535421516744176,
    -50.5846456149812,
    -52.4177319717718,
    8.904400565585357,
    48.90844652268478,
    24.110308640941884,
    47.89254184111739,
    36.44584004528133,
    -14.181133749254569,
    34.83915966525287,
    -22.769834932198194,
    44.56614564910118,
    50.26848367978522,
    -48.81609005457233,
    47.83853570952319,
    9.089276402960177,
    62.1026538441096,
    -24.57853193983756,
    9.008370651187423,
    65.87134337114765,
    -30.236087585084725,
    -53.62170713473155,
    71.02349063397882,
    -47.77210344459178,
    29.005567109546057,
    -14.200028791117498,
    45.176092596921066,
    41.92148862279129,
    -18.2965494960799,
    -42.76290394319444,
    28.811525074133648,
    30.15111877399235,
]);

const SYMBOLS_HB9AK: Symbols<f64> = Symbols([
    1.830423163660683,
    -3.20094779348951,
    3.1319457667177613,
    -0.3812403361512873,
    0.3772035103290765,
    -5.123001827476691,
    1.4535338045531003,
    4.407031146498607,
    -5.258359464453282,
    -5.825839491066104,
    -5.79532428531944,
    1.8131252797044348,
    -0.8948541800706646,
    5.7852661443697215,
    3.279439041163806,
    8.700630540486209,
    3.7544877794589615,
    -0.7163399210006043,
    7.96983384545968,
    1.4800464776369147,
    -3.869790706864603,
    -0.3944276764958077,
    15.16409803823688,
    4.471554397179859,
    -2.974000708702529,
    -13.685995956216683,
    -6.445629359240295,
    10.278667748897263,
    -4.2113298515477,
    7.269377867803711,
    5.978387533867939,
    3.04233395009592,
    6.4813080778206364,
    5.004993804266807,
    -4.47051716491965,
    3.5279519977397813,
    -2.4966752325534345,
    -7.725460069122354,
    -3.1980297625149317,
    -12.698926968015362,
    -2.0611934006617854,
    -4.873083087358372,
    -13.849512200527903,
    1.1667827431749207,
    2.5945576036503315,
    3.85005749762239,
    2.3427796420583387,
    -2.7658530778653403,
    -9.0295824237257,
    1.2136699841065886,
    -1.7417610560024395,
    -0.8663920240962644,
    -2.2932978901289665,
    -8.115488375686157,
    -2.1838901557088604,
    3.6690525151923836,
    -4.108794625967922,
    -3.710830190993811,
    -0.25630934141892636,
    -6.372899627961345,
    7.12457768808366,
    -0.17092758827472765,
    12.249539806538479,
    -1.9663950022271015,
    -1.8686427793687903,
    -5.841211322034706,
    -6.332241633718617,
    -0.8793406409434734,
    -1.489278515586789,
    -1.5072107407688027,
    0.9658859570704346,
    3.674627233145296,
    -8.831659340456145,
    -4.037796747892685,
    -4.37212560948047,
    9.836258721358975,
    1.4093511303849278,
    -4.266784325597956,
    -5.617120329252347,
    10.460608056143075,
    -2.7335561796212486,
    0.82701733683085,
    -16.339090929778628,
    -2.5932511718160014,
    -0.23339711516218142,
    1.4649058081269755,
    0.41825844036923465,
    2.4161958942402935,
    1.7112784625078699,
    10.240994744303741,
    0.030433237019683368,
    2.9189932733073567,
    -0.6231980927642216,
    1.5724607703232953,
    -5.954981894910094,
    -5.254544422638644,
    -2.4596029551868144,
    -1.5143721017934613,
    5.3576435789996655,
    -4.076436211159397,
    -0.9550394994996649,
    -9.003465932628782,
    0.6831472570857963,
    16.74650087372568,
    -3.102766818329145,
    -3.24992931838512,
    2.63691017074797,
    0.095567938548208,
    3.630645374713521,
    -5.290920925141395,
    7.0165718762083085,
    -8.893667074594218,
    -3.2342094969908812,
    -6.685700998998581,
    0.5104289738733043,
    -5.919270639373799,
    -12.971804310611596,
    -0.6074607264327296,
    -5.27846754299817,
    -6.758903231252665,
    6.745131556359201,
    1.6809809400770355,
    -1.562330740399377,
    -5.1563818403965485,
    -2.464736380935785,
    3.509502650169278,
    -5.233933775855135,
    2.1868964257878,
    7.462813788323883,
    9.073285485730056,
    -2.1159015205365463,
    4.477164928799487,
    2.501592409114501,
    3.597438952553039,
    -7.662810147956376,
    -1.5076994820529706,
    3.0750278506439566,
    3.0075349491938095,
    -13.016042751745966,
    4.158500934230483,
    5.504040634531311,
    -3.9487187733546416,
    -2.8469097164122292,
    -9.216395543748485,
    2.8845776087180597,
    1.8302553239629589,
    0.6067282553856179,
    -2.099158950606304,
    5.408896006351549,
    6.89978806385422,
    -1.9001259326347038,
    -2.592664663276644,
    -4.321588858536608,
    -8.14953572401278,
    5.383902891553189,
    -9.909287240775676,
    9.91919740403005,
    2.9333609578910087,
    -1.5507404096356918,
    -2.2980270751618064,
    6.552694772881246,
    12.238687132263705,
]);
